#! /bin/sh

. /etc/default/devpts

[ `uname -s` = "Linux" ] || exit 0

make_devptmx()
{
    if [ ! -c /dev/ptmx ]; then
	mknod /dev/ptmx c 5 2
	chmod 666 /dev/ptmx
    fi
}

mount_devpts()
{
    if [ ! -d /dev/pts ]; then
	mkdir /dev/pts
	chmod 755 /dev/pts
    fi
    mount -t devpts devpts /dev/pts \
    -ogid=${TTYGRP},mode=${TTYMODE} > /dev/null 2>&1
}

release=`uname -r`
tail=${release#*.*.}
major_release=${release%.${tail}}
minor_release=${tail%%[-.]*}

case ${major_release} in
    2.[23456789] | 3.*)
	devpts=$(grep -c devpts /proc/filesystems)
	if [ $devpts -eq 1 ]
	then
	    make_devptmx
	    mount_devpts
	fi
    ;;
    2.1)
	if [ ${minor_release} -gt 115 ]
	then
	    devpts=$(grep -c devpts /proc/filesystems)
	    if [ $devpts -eq 1 ]
	    then
		make_devptmx
		mount_devpts
	    fi
	fi
    ;;
esac

exit 0
